# Requests with Whitelisted IPs

With Whitelisted IPs, you can access Oxylabs Residential Proxies **without needing to provide a `username` and `password`**. By whitelisting your IP address, you can specify all your proxy parameters **directly in the subdomain.**&#x20;

If you add an IP to the whitelist, you should connect using **either the whitelisted IP or credentials**, but not both, as doing so can lead to unexpected behavior.

#### Code example&#x20;

Here's an example code targeting New York City with a given session ID:&#x20;

{% tabs %}
{% tab title="cURL" %}

```shell
curl -x https://cc-us-city-new_york-sessid-test123.bc.pr.oxylabs.io:7777 https://ip.oxylabs.io/location
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php
$session_id = 'test123';  // Your session ID
$city = 'new_york';  // The city you want to target
$proxy = "cc-us-city-$city-sessid-$session_id.bc.pr.oxylabs.io:7777";
$query = curl_init('https://ip.oxylabs.io/location');

curl_setopt($query, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($query, CURLOPT_PROXY, "http://$proxy");
$output = curl_exec($query);
curl_close($query);

if ($output)
    echo $output;
?>

```

{% endtab %}

{% tab title="Python" %}

```python
import urllib.request

session_id = 'test123'  # Your session ID
city = 'new_york'  # The city you want to target
proxy = 'cc-us-city-%s-sessid-%s.bc.pr.oxylabs.io:7777' % (city, session_id)

query = urllib.request.ProxyHandler({
    'http': proxy,
    'https': proxy,
})

execute = urllib.request.build_opener(query)
print(execute.open('https://ip.oxylabs.io/location').read())

```

{% endtab %}

{% tab title="Java" %}

```java
package example;

import org.apache.http.HttpHost;
import org.apache.http.client.fluent.*;

public class Example {
    public static void main(String[] args) throws Exception {
        HttpHost entry = new HttpHost("cc-us-city-new_york-sessid-test123.bc.pr.oxylabs.io", 7777);

        String query = Executor.newInstance()
            .execute(Request.Get("http://ip.oxylabs.io/location").viaProxy(entry))
            .returnContent().asString();
        
        System.out.println(query);
    }
}

```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Net;

class Example
{
    static void Main()
    {
        var client = new WebClient();
        
        client.Proxy = new WebProxy("cc-us-city-new_york-sessid-test123.bc.pr.oxylabs.io:7777");

        Console.WriteLine(client.DownloadString("https://ip.oxylabs.io/location"));
    }
}

```

{% endtab %}

{% tab title="Go" %}

```ruby
package main

import (
	"fmt"
	"io/ioutil"
	"net/http"
	"net/url"
)

func main() {
	proxyURL, _ := url.Parse("https://cc-us-city-new_york-sessid-test123.bc.pr.oxylabs.io:7777")
	client := &http.Client{Transport: &http.Transport{Proxy: http.ProxyURL(proxyURL)}}

	resp, err := client.Get("https://ip.oxylabs.io/location")
	if err != nil {
		fmt.Println("Error:", err)
		return
	}
	defer resp.Body.Close()

	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))
}
```

{% endtab %}
{% endtabs %}

**Query parameters**

| Parameter    | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| ------------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `cc`         | Case insensitive country code in 2-letter [**3166-1 alpha-2 format**](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2). For example, `DE` for Germany, `GB` for the United Kingdom, `TH` for Thailand. You can find more details on how to use country-specific proxies [**here**](https://developers.oxylabs.io/proxies/residential-proxies/location-settings/select-country).                                                                                                              |
| `city`       | Case insensitive city name in English. This parameter must be accompanied by `cc` for better accuracy, for example, `cc-GB-city-london` for London, United Kingdom; `cc-DE-city-berlin` for Berlin, Germany. For a city with more than two words, replace space with `_`, for example, `city-st_petersburg` or `city-rio_de_janeiro`. Click [**here**](https://developers.oxylabs.io/proxies/residential-proxies/location-settings/select-city) for more information on city-level targeting. |
| `st`         | Case insensitive US state name with us\_ in the beginning, for example, `us_california`, `us_illinois`. [**Click here** ](https://developers.oxylabs.io/proxies/residential-proxies/location-settings/select-state)for more information on state-level targeting.                                                                                                                                                                                                                             |
| `cn`         | To get a proxy from any of the seven continents, add the `cn-`  parameter and two-letter code to the authorization string. Click here for more information on continent-level targeting                                                                                                                                                                                                                                                                                                       |
| `postalcode` | <p>To connect to a proxy using a ZIP code, add and specify the <code>postalcode</code> parameter with a <strong>five-digit</strong> ZIP code. This parameter must be used combined with the country code parameter <code>cc</code> and a case-insensitive country code in 2-letter <a href="https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2"><strong>3166-1 alpha-2 format</strong></a>. <br><a href="../location-settings/zip-postal-code">Learn more here.</a></p>                         |
| `ASN`        | You can choose proxies from specific carriers. You have to enter the required ASN number in your request. [Learn more here](https://developers.oxylabs.io/proxies/residential-proxies/location-settings/asn-targeting).                                                                                                                                                                                                                                                                       |
| `sessid`     | Session ID to keep the same IP with upcoming queries. The session expires in 10 minutes. After that, a new IP address is assigned to that session ID. Random string, 0-9, and A-Z characters are supported.                                                                                                                                                                                                                                                                                   |
| `sesstime`   | The session time parameter keeps the same IP for a certain period. The maximum session time is 30 minutes.                                                                                                                                                                                                                                                                                                                                                                                    |
